.PS
# `AlogixSVG.m4'
log_init
  command "<g font-family=\"sans-serif\">"
  textht=11.5bp__

#                             A modest expression in default form
A: Autologix(
    Nand(And(Or(A,C),Or(B,~C),Or(~A,B,C)),Ck);
    Nand(~A,B)@with .n at last [].s+(0,-2bp__))
    "Out1" at A.Out1 ljust
    "Out2" at A.Out2 ljust
    Loopover_(`v_', `"v_" at A.In`'v_ above ', A,B,C,Ck)
    move left 0.2 from A.w
  `"Autologix("' wid 55bp__ with .w at A.sw+(0,-0.15)
  `"Nand(And(Or(A,C),Or(B,~C),Or(~A,B,C)),Ck);"' \
      wid 250bp__ with .w at last "".w+(0.2,-0.18)
  `"Nand(~A,B)@with .n at last [].s+(0,-2bp__))"'\
    wid 240bp__ with .w at last "".w+(0,-0.18)

#                             Draw a tree of gates only using the N option.
B: Autologix(Or(And(B,Not(C)),And(Not(A),B,C)),N) \
  with .sw at A.e+(1.4,-0.35)
  O: "Out" wid 22bp__ at B.Out above ljust
  `"Autologix(Or(And(B,Not(C)),And(Not(A),B,C)),N)"' \
     wid 268bp__ with .e at (last "".e,B.s) +(0,-0.15)
  for_(1,5,1,`"B.In`'m4x" ht 10bp__ at B.In`'m4x rjust')


#                             Here is how to include an arbitrary circuit
#                             that is not one of the standard gates.
#                             First, define the circuit with a name ending
#                             in _gate.  Make sure its inputs are on the left
#                             and named In1, In2, ... and the output Out
#                             is on the right.
define(`SR_gate',`[
  S: NOR_gate
  R: NOR_gate at S+(0,-L_unit*(AND_ht+4))
     w = (S.Out.x-R.In1.x)/3
     v = 2*L_unit
     line right_ dimen_/2 from S.Out
  Out: Here
     TR: R.In1-(v,0)
     line from S.Out+(v,0) down w*3/2 then left S.Out.x-TR.x+v down w \
        then to TR then to R.In1
     TS: S.In2-(v,0);
     line from R.Out right v then up w*3/2 then left R.Out.x-TS.x+v up w \
        then to TS then to S.In2
  In1: S.In1
  In2: R.In2 ]')
#                             Now define the function by which the circuit
#                             will be invoked:
define(`SRff',`_AutoGate(SR,$@)')

#                             You are done.  Here is an example:
  F: Autologix(SRff(And(x,y),Nand(x,y)),LRV) \
    with .sw at A.n+(0.5,-0.15)
  O: "Out" wid 22bp__ at F.Out ljust

  "x" at F.Inx rjust
  "y" at F.Iny rjust
  `"Autologix(SRff(And(x,y),Nand(x,y)),LRV)"' wid 230bp__ \
    with .w at F.sw+(0,-10bp__)

 command "</g>"
.PE
